import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

import {
  InstanceNameType,
} from '@overflow/commons/di/type';

export interface InstanceAnnotationAttributes {
  name?: InstanceNameType;
  initMethod?: Function;
  destroyMethod?: Function;
}

export class InstanceAnnotation extends Annotation {
  public readonly attributes: InstanceAnnotationAttributes = {
  };

  public constructor(name: InstanceNameType | InstanceAnnotationAttributes) {
    super();
    if (undefined === name) {
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes.name = <InstanceNameType>name;
    } else {
      this.copyAttributes(this.attributes, <InstanceAnnotationAttributes>name);
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('Instance');
  }

}

export const Instance = Decorator.create(InstanceAnnotation);
