import { IllegalArgumentError } from '../type/error';
import { StringUtils } from './string';



export abstract class Assert {
  /**
   * isTrue
   */
  public static isTrue(expression: boolean, message?: string): void {
      if (!expression) {
      throw new IllegalArgumentError(undefined !== message ? message : '[Assertion failed] - this expression must be true');
    }
  }

  /**
   * isUndefined
   */
  public static isUndefined(obj: any, message?: string): void {
    if (undefined !== obj) {
      throw new IllegalArgumentError(undefined !== message ? message : '[Assertion failed] - the object argument must be undefined');
    }
  }

  /**
   * notUndefined
   */
  public static notUndefined(obj: any, message?: string): void {
    if (undefined === obj) {
      throw new IllegalArgumentError(undefined !== message ? message : '[Assertion failed] - the object argument must not be undefined');
    }
  }


  /**
   * isNull
   */
  public static isNull(obj: any, message?: string): void {
    if (undefined === obj || null !== obj) {
      throw new IllegalArgumentError(undefined !== message ? message : '[Assertion failed] - the object argument must be null');
    }
  }

  /**
   * isNull
   */
  public static notNull(obj: any, message?: string): void {
    if (undefined === obj || null === obj) {
      throw new IllegalArgumentError(undefined !== message ? message : '[Assertion failed] - the object argument must not be null');
    }
  }

  /**
   * isNull
   */
  public static hasLength(text: string, message?: string): void {
    if (!StringUtils.hasLength(text)) {
      throw new IllegalArgumentError(
        undefined !== message
        ? message
        : '[Assertion failed] - this String argument must have length; it must not be null or empty',
      );
    }
  }


}
