import {
  Annotation,
} from '@overflow/commons/core/reflect';

import {
  ClassType,
} from '@overflow/commons/core/type';

import {
  InjectModeType,
  InstanceNameType,
} from '@overflow/commons/di/type';

import { InstanceDefinition } from './instance_definition';
import { InstanceDefinitionRegistry } from './instance_definition_registry';

export class InstanceFactory {
  private _instanceDefinitionRegistry: InstanceDefinitionRegistry;


  public get instanceDefinitionRegistry(): InstanceDefinitionRegistry {
    return this._instanceDefinitionRegistry;
  }

  // Instance

  public getInstance(name: InstanceNameType | undefined, requiredType: ClassType | undefined, ...args: any[]): any | undefined {
    return undefined;
  }
  public containsInstance(name: InstanceNameType): boolean {
    return false;
  }
  public isSingleton(name: InstanceNameType): boolean {
    return false;
  }
  public isTransiant(name: InstanceNameType): boolean {
    return false;
  }
  public isTypeMatch(name: InstanceNameType, typeToMatch: ClassType): boolean {
    return false;
  }
  public getType(name: InstanceNameType): ClassType {
    return undefined;
  }
  public getAliases(name: InstanceNameType): InstanceNameType[] {
    return undefined;
  }

  // Create Instance

  public createInstance<T>(clazzType: ClassType<T>, injectMode?: InjectModeType, dependencyCheck?: boolean): T {
    return undefined;
  }

  public injectInstance(instance: any): void {
    //
  }

  public inject(clazzType: ClassType, injectMode?: InjectModeType, dependencyCheck?: boolean): any {
    //
  }

  public injectInstanceProperties(instance: any, injectMode: InjectModeType, dependencyCheck: boolean): void {
    //
  }

  public applyInstancePropertyValues(instance: any, name: InstanceNameType): void {
    //
  }

  public initializeInstance(instance: any, name: InstanceNameType): any {
    //
  }

  public applyInstancePostProcessorsBeforeInitialization(instance: any, name: InstanceNameType): any {
    //
  }

  public applyInstancePostProcessorsAfterInitialization(instance: any, name: InstanceNameType): any {
    //
  }

  public configureInstance(instance: any, name: InstanceNameType): any {
    //
  }

  public destroyInstance(instance: any): any {
    //
  }

  public resolveDependency(descriptor: DependencyDescriptor, name: InstanceNameType, injectInstanceNames?: Set<InstanceNameType>): any {
    //
  }

  public getInstanceNamesIterator(): IterableIterator<InstanceNameType> {
    return undefined;
  }

  // InstanceDefinition

  public getInstanceDefinition(): InstanceDefinition {
    return undefined;
  }

  public containsInstanceDefinition(name: InstanceNameType): boolean {
    return false;
  }
  public getInstanceDefinitionCount(): number {
    return 0;
  }
  public getInstanceDefinitionNames(): InstanceNameType[] {
    return undefined;
  }
  public getInstanceNamesForType(clazzType: ClassType, includeNonSingletons?: boolean, allowEagerInit?: boolean): InstanceNameType[] {
    return undefined;
  }
  public getInstancesOfType<T>(clazzType: ClassType, includeNonSingletons?: boolean, allowEagerInit?: boolean): Map<InstanceNameType, T> {
    return undefined;
  }
  public getInstanceNamesForAnnotation<AnnotationType extends Annotation>(annotation: AnnotationType): InstanceNameType[] {
    return undefined;
  }
  public getInstancesWithAnnotation<AnnotationType extends Annotation>(annotation: AnnotationType): Map<InstanceNameType, any> {
    return undefined;
  }
  public findAnnotationOnInstance<AnnotationType extends Annotation>(name: InstanceNameType, annotation: AnnotationType): AnnotationType {
    return undefined;
  }


  // Configuration

  public ignoreDependencyType(clazzType: ClassType): void {
    //
  }

  public registerResolvableDependency(dependencyType: ClassType, injectValue: any): void {
    //
  }

  public isInjectCandidate(name: InstanceNameType, descriptor: DependencyDescriptor): boolean {
    return false;
  }
}
